<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>계산기</title>
</head>
<body>
    <script>
        /* 스택 클래스 */
        class Stack {
            /* 데이터를 담을 생성자 함수로 변수 선언 */
            constructor() {
                this.arr = [];
            };
            /* 데이터를 배열의 맨위에 넣는 메서드 */
            push(data) {
                this.arr.push(data);
            };
            /* 데이터를 맨위에서 빼는 메서드 */
            pop() {
                return this.arr.pop();
            };
            /* 맨위에 데이터가 무엇인지 확인하는 메서드 */
            check() {
                return this.arr[this.arr.length - 1];
            };
            /* 스택의 data 갯수 확인 */
            count() {
                return this.arr.length;
            };
        };

        // 중위식 수식을 후위식 수식으로 변경
        let str = prompt("계산할 수식을 입력하세요.");
        // 수식을 후위식으로 변경 할당될 변수 선언
        let postfix = "";
        // 스택 인스턴스 생성
        let s = new Stack();
        for (let i = 0; i < str.length; i++) {
            // 숫자가 등장하면 postfix 에 숫자를 붙여 넣는다.
            if (!isNaN(parseInt(str[i]))) {
                postfix += str[i];
            } // 여는 괄호면 스텍에 push 한다.
            else if (str[i] == "(")
            {
                s.push(str[i]);
            } // 닫는 괄호면 s 스택에 여는 괄호가 나올때까지 모든 연산자를 pop 하여 postfix 의 오른쪽 끝에 붙여 넣고 스택에 남아 있는 여는 괄호는 제거한다.
            else if (str[i] == ")")
            {
                while (s.check() != "(") {
                    postfix += s.pop();
                };
                s.pop();
            } // +, - 이면 스택 s 에 push 한다.
            else if ( str[i] == "+" || str[i] == "-" )
            {
                s.push(str[i]);
            } // *, / 이면 스택의 맨위 데이터가 * 나 / 이면, 스택 s 에서 pop 하여 postfix 의 오른쪽 끝에 붙여넣고, 스텍 s에 push 한다.
            else if ( str[i] == "*" || str[i] ==  "/" )
            {
                while (s.check() == "*" || s.check() == "/") {
                    postfix += s.pop();
                }
                s.push(str[i]);
            }
        };
        /* 스택 s에 들어 있는 연산자 postfix 오른쪽 끝에 붙여넣기*/
        while (s.count()) {
            postfix += s.pop();
        }
        console.log("후위표기식 :", postfix);

        /* 후위표기식 계한하기*/
        // 스텍 s에서 pop 하여 계산할 변수 선언
        let num1, num2;
        // postfix 의 0 번 인덱스부터 문자열 끝까지 순회한다.
        for (let i = 0; i < postfix.length; i++) {
            // 순회하며 숫자를 만나면 스택 s에 push 한다.
            if (!isNaN(parseInt(postfix.charAt(i)))) {
                s.push(parseInt(postfix.charAt(i)));
            } // 연산자가 + 이면
            else if (postfix.charAt(i) == "+") {
                num1 = s.pop();
                num2 = s.pop();
                s.push(num2 + num1);
            }
            else if (postfix.charAt(i) == "-") {
                num1 = s.pop();
                num2 = s.pop();
                // -, / 연산은 스택 pop 할때 먼저 나온 것이 두번째 피연산자로 둬야 정상 계산된다.
                s.push(num2 - num1);
            }
            else if (postfix.charAt(i) == "*") {
                num1 = s.pop();
                num2 = s.pop();
                s.push(num2 * num1);
            }
            else if (postfix.charAt(i) == "/") {
                num1 = s.pop();
                num2 = s.pop();
                s.push(num2 / num1);
            }
        };
        console.log(s.pop());
    </script>
</body>
</html>